=== plugins/config/CMakeLists.txt ===
INCLUDE(BuildVeyonPlugin)

build_veyon_plugin(config ConfigCommandLinePlugin.cpp ConfigCommandLinePlugin.h)
