=== plugins/powercontrol/CMakeLists.txt ===
INCLUDE(BuildVeyonPlugin)

build_veyon_plugin(powercontrol
	PowerControlFeaturePlugin.cpp
	PowerControlFeaturePlugin.h
	PowerDownTimeInputDialog.cpp
	PowerDownTimeInputDialog.h
	PowerDownTimeInputDialog.ui
	powercontrol.qrc
)
